





















































































































 


































































































































































 
















































































































































































































 























































 










 








































































































































































































































 










                                
                                

                                
                                

                                
                                

                                



















































































subroutine NullNews_ScriVals (cctk_dim,cctk_gsh,cctk_lsh,cctk_lbnd,cctk_ubnd,cctk_tile_min,cctk_tile_max,cctk_ash,cctk_alignment,cc&
  &tk_alignment_offset,cctk_from,cctk_to,cctk_bbox,cctk_delta_time,cctk_time,cctk_delta_space,cctk_origin_space,cctk_levfac,cctk_le&
  &voff,cctk_levoffdenom,cctk_timefac,cctk_convlevel,cctk_convfac,cctk_nghostzones,cctk_iteration,cctkGH,cctk_ash1,cctk_ash2,cctk_a&
  &sh3, CNewsArrs_length,RNewsArrs_length,X0CNewsArrs,X0CmplxGA,X0RNewsArrs,X0ReGA,X0YlmScri_group,X0patch_index,X1CNewsArrs,X1Cmpl&
  &xGA,X1RNewsArrs,X1ReGA,X1YlmScri_group,X1patch_index,YlmScri_group_length,patch_index_length,Jn,Jo,P,Qn,Qn_l,Qo,Qo_l,Un,Un_l,Un_&
  &l_l,Uo,Uo_l,Uo_l_l,Uyn,Uyo,Wn,YlmScri_0,YlmScri_1,YlmScri_2,betan,betao,cBn,cBo,circle,comegan,comegao,dMdOmega,deltan,deltao,n_&
  &tmp1_cgfn,n_tmp1_cgfs,n_tmp1_rgfn,n_tmp1_rgfs,n_tmp2_cgfn,n_tmp2_cgfs,n_tmp2_rgfn,n_tmp2_rgfs,n_tmp3_cgfn,n_tmp3_cgfs,nzeta,nzet&
  &abar,patch_index,redshiftB,sigmaJn,sigmaJo,sigmaKn,sigmaKo,sigmarn,sigmaro,sigmarun,sigmaruo,sigmaun,sigmauo,sigmauun,sigmauuo,s&
  &tarting,uBondin,uBondio,zEvolh,zEvoln,zEvolo, JJ_l_length,NewsB_length,NewsB_past_length,NewsB_uBondi_length,News_length,News_pa&
  &st_length,News_uBondi_length,Psi4_length,Psi4_past_length,Psi4_uBondi_length,X0EG_mask,X0EQ_mask,X0EV_mask,X0JJ_l,X0News,X0NewsB&
  &,X0NewsB_past,X0NewsB_uBondi,X0News_past,X0News_uBondi,X0NullGrParArrI,X0NullGrParArrR,X0Psi4,X0Psi4_past,X0Psi4_uBondi,X0RadCrd&
  &,X0StCmCrd,X0StCrd,X0cmplxcharfuncs_aux,X0cmplxcharfuncs_basic,X0guard_mask,X0linStrain,X0linStrain_past,X0linStrain_uBondi,X0nu&
  &ll_mask,X0omega,X0realcharfuncs,X0tmp_cgf,X0tmp_cgf3,X0tmp_rgf,X0uBondi,X0uBondi_past,X1EG_mask,X1EQ_mask,X1EV_mask,X1JJ_l,X1New&
  &s,X1NewsB,X1NewsB_past,X1NewsB_uBondi,X1News_past,X1News_uBondi,X1Psi4,X1Psi4_past,X1Psi4_uBondi,X1StCmCrd,X1StCrd,X1cmplxcharfu&
  &ncs_aux,X1cmplxcharfuncs_basic,X1guard_mask,X1linStrain,X1linStrain_past,X1linStrain_uBondi,X1null_mask,X1omega,X1realcharfuncs,&
  &X1tmp_cgf,X1tmp_cgf3,X1tmp_rgf,X1uBondi,X1uBondi_past,cmplxcharfuncs_aux_length,cmplxcharfuncs_basic_length,linStrain_length,lin&
  &Strain_past_length,linStrain_uBondi_length,omega_length,realcharfuncs_length,uBondi_length,uBondi_past_length,EG_mask,EQ_mask,EV&
  &_mask,Jn_l,Jo_l,News,NewsB,NewsB_past,NewsB_uBondi,News_past,News_uBondi,Psi4,Psi4_past,Psi4_uBondi,bcn,bcn_p,bcs,bcs_p,boundary&
  &_maskn,boundary_masks,cbcn,cbcn_p,cbcs,cbcs_p,ckcn,ckcn_p,ckcs,ckcs_p,constant_uBondi,dxjcn,dxjcn_p,dxjcs,dxjcs_p,eth2jcn,eth2jc&
  &n_p,eth2jcs,eth2jcs_p,evolution_maskn,evolution_masks,evolution_radius,guard_mask,jcn,jcn_p,jcs,jcs_p,linStrain,linStrain_past,l&
  &inStrain_uBondi,nucn,nucn_p,nucs,nucs_p,null_delta,null_dx,null_gsh,null_lbnd,null_lsh,null_rb,null_rbh,null_ubnd,null_xb,null_x&
  &bh,omegan,omegao,qcn,qcn_p,qcs,qcs_p,qsize,stereo_p,stereo_pp,stereo_q,time_of_news,tmp_cgfn,tmp_cgfn1,tmp_cgfn2,tmp_cgfn3,tmp_c&
  &gfs,tmp_cgfs1,tmp_cgfs2,tmp_cgfs3,tmp_rgfn,tmp_rgfs,uBondi,uBondi_past,ucn,ucn_p,ucs,ucs_p,wcn,wcn_p,wcs,wcs_p,zeta)
  use NullNews_ScriUtil
  use NullDecomp_SpinDecomp, only: SpinDecompFilter

  implicit none

  LOGICAL, SAVE :: FirstTime = .true.
  COMPLEX*16, DIMENSION(:,:,:), ALLOCATABLE,  SAVE :: temp

  interface
  integer*8 function CCTK_PointerTo (var)
  implicit none
  type(*),dimension(..),TARGET :: var
  end function CCTK_PointerTo
  end interface
  interface
  integer function CCTK_Equals (arg1, arg2)
  implicit none
  integer*8 arg1
  character(*) arg2
  end function CCTK_Equals
  integer function CCTK_MyProc (cctkGH)
  implicit none
  integer*8 cctkGH
  end function CCTK_MyProc
  integer function CCTK_nProcs (cctkGH)
  implicit none
  integer*8 cctkGH
  end function CCTK_nProcs
  integer function CCTK_IsThornActive (name)
  implicit none
  character(*) name
  end function CCTK_IsThornActive
  integer*8 function CCTK_NullPointer ()
  implicit none
  end function CCTK_NullPointer
  end interface
  interface
  INTEGER*4 function IO_TruncateOutputFiles (GH)
  implicit none
  integer*8 GH
  end function IO_TruncateOutputFiles
  end interface

  INTEGER cctk_dim
  integer, parameter :: cctki_use_cctk_dim = kind(cctk_dim)
  INTEGER cctk_gsh (cctk_dim)
  integer, parameter :: cctki_use_cctk_gsh = kind(cctk_gsh)
  INTEGER cctk_lsh (cctk_dim)
  integer, parameter :: cctki_use_cctk_lsh = kind(cctk_lsh)
  INTEGER cctk_lbnd (cctk_dim)
  integer, parameter :: cctki_use_cctk_lbnd = kind(cctk_lbnd)
  INTEGER cctk_ubnd (cctk_dim)
  integer, parameter :: cctki_use_cctk_ubnd = kind(cctk_ubnd)
  INTEGER cctk_tile_min (cctk_dim)
  integer, parameter :: cctki_use_cctk_tile_min = kind(cctk_tile_min)
  INTEGER cctk_tile_max (cctk_dim)
  integer, parameter :: cctki_use_cctk_tile_max = kind(cctk_tile_max)
  INTEGER cctk_ash (cctk_dim)
  integer, parameter :: cctki_use_cctk_ash = kind(cctk_ash)
  INTEGER cctk_alignment
  integer, parameter :: cctki_use_cctk_alignment = kind(cctk_alignment)
  INTEGER cctk_alignment_offset
  integer, parameter :: cctki_use_cctk_alignment_offset = kind(cctk_alignment_offset)
  INTEGER cctk_from (cctk_dim)
  integer, parameter :: cctki_use_cctk_from = kind(cctk_from)
  INTEGER cctk_to (cctk_dim)
  integer, parameter :: cctki_use_cctk_to = kind(cctk_to)
  INTEGER cctk_bbox (2*cctk_dim)
  integer, parameter :: cctki_use_cctk_bbox = kind(cctk_bbox)
  REAL*8 cctk_delta_time
  integer, parameter :: cctki_use_cctk_delta_time = kind(cctk_delta_time)
  REAL*8 cctk_time
  integer, parameter :: cctki_use_cctk_time = kind(cctk_time)
  REAL*8 cctk_delta_space (cctk_dim)
  integer, parameter :: cctki_use_cctk_delta_space = kind(cctk_delta_space)
  REAL*8 cctk_origin_space (cctk_dim)
  integer, parameter :: cctki_use_cctk_origin_space = kind(cctk_origin_space)
  INTEGER cctk_levfac (cctk_dim)
  integer, parameter :: cctki_use_cctk_levfac = kind(cctk_levfac)
  INTEGER cctk_levoff (cctk_dim)
  integer, parameter :: cctki_use_cctk_levoff = kind(cctk_levoff)
  INTEGER cctk_levoffdenom (cctk_dim)
  integer, parameter :: cctki_use_cctk_levoffdenom = kind(cctk_levoffdenom)
  INTEGER cctk_timefac
  integer, parameter :: cctki_use_cctk_timefac = kind(cctk_timefac)
  INTEGER cctk_convlevel
  integer, parameter :: cctki_use_cctk_convlevel = kind(cctk_convlevel)
  INTEGER cctk_convfac
  integer, parameter :: cctki_use_cctk_convfac = kind(cctk_convfac)
  INTEGER cctk_nghostzones (cctk_dim)
  integer, parameter :: cctki_use_cctk_nghostzones = kind(cctk_nghostzones)
  INTEGER cctk_iteration
  integer, parameter :: cctki_use_cctk_iteration = kind(cctk_iteration)
  integer*8 cctkGH
  integer, parameter :: cctki_use_cctkGH = kind(cctkGH)
  INTEGER cctk_ash1
  integer, parameter :: cctki_use_cctk_ash1 = kind(cctk_ash1)
  INTEGER cctk_ash2
  integer, parameter :: cctki_use_cctk_ash2 = kind(cctk_ash2)
  INTEGER cctk_ash3
  integer, parameter :: cctki_use_cctk_ash3 = kind(cctk_ash3)
  INTEGER CNewsArrs_length
  INTEGER RNewsArrs_length
  INTEGER X0CNewsArrs
  INTEGER X0CmplxGA
  INTEGER X0RNewsArrs
  INTEGER X0ReGA
  INTEGER X0YlmScri_group
  INTEGER X0patch_index
  INTEGER X1CNewsArrs
  INTEGER X1CmplxGA
  INTEGER X1RNewsArrs
  INTEGER X1ReGA
  INTEGER X1YlmScri_group
  INTEGER X1patch_index
  INTEGER YlmScri_group_length
  INTEGER patch_index_length
  COMPLEX*16 Jn (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_Jn = kind(Jn)
  COMPLEX*16 Jo (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_Jo = kind(Jo)
  REAL*8 P (X0RNewsArrs,X1RNewsArrs,RNewsArrs_length)
  integer, parameter :: cctki_use_P = kind(P)
  COMPLEX*16 Qn (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_Qn = kind(Qn)
  COMPLEX*16 Qn_l (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_Qn_l = kind(Qn_l)
  COMPLEX*16 Qo (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_Qo = kind(Qo)
  COMPLEX*16 Qo_l (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_Qo_l = kind(Qo_l)
  COMPLEX*16 Un (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_Un = kind(Un)
  COMPLEX*16 Un_l (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_Un_l = kind(Un_l)
  COMPLEX*16 Un_l_l (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_Un_l_l = kind(Un_l_l)
  COMPLEX*16 Uo (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_Uo = kind(Uo)
  COMPLEX*16 Uo_l (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_Uo_l = kind(Uo_l)
  COMPLEX*16 Uo_l_l (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_Uo_l_l = kind(Uo_l_l)
  COMPLEX*16 Uyn (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_Uyn = kind(Uyn)
  COMPLEX*16 Uyo (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_Uyo = kind(Uyo)
  REAL*8 Wn (X0RNewsArrs,X1RNewsArrs,RNewsArrs_length)
  integer, parameter :: cctki_use_Wn = kind(Wn)
  COMPLEX*16 YlmScri_0 (X0YlmScri_group,X1YlmScri_group,YlmScri_group_length)
  integer, parameter :: cctki_use_YlmScri_0 = kind(YlmScri_0)
  COMPLEX*16 YlmScri_1 (X0YlmScri_group,X1YlmScri_group,YlmScri_group_length)
  integer, parameter :: cctki_use_YlmScri_1 = kind(YlmScri_1)
  COMPLEX*16 YlmScri_2 (X0YlmScri_group,X1YlmScri_group,YlmScri_group_length)
  integer, parameter :: cctki_use_YlmScri_2 = kind(YlmScri_2)
  REAL*8 betan (X0RNewsArrs,X1RNewsArrs,RNewsArrs_length)
  integer, parameter :: cctki_use_betan = kind(betan)
  REAL*8 betao (X0RNewsArrs,X1RNewsArrs,RNewsArrs_length)
  integer, parameter :: cctki_use_betao = kind(betao)
  COMPLEX*16 cBn (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_cBn = kind(cBn)
  COMPLEX*16 cBo (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_cBo = kind(cBo)
  REAL*8 circle (X0RNewsArrs,X1RNewsArrs,RNewsArrs_length)
  integer, parameter :: cctki_use_circle = kind(circle)
  COMPLEX*16 comegan (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_comegan = kind(comegan)
  COMPLEX*16 comegao (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_comegao = kind(comegao)
  REAL*8 dMdOmega (X0RNewsArrs,X1RNewsArrs,RNewsArrs_length)
  integer, parameter :: cctki_use_dMdOmega = kind(dMdOmega)
  REAL*8 deltan (X0RNewsArrs,X1RNewsArrs,RNewsArrs_length)
  integer, parameter :: cctki_use_deltan = kind(deltan)
  REAL*8 deltao (X0RNewsArrs,X1RNewsArrs,RNewsArrs_length)
  integer, parameter :: cctki_use_deltao = kind(deltao)
  COMPLEX*16 n_tmp1_cgfn (X0CmplxGA,X1CmplxGA)
  integer, parameter :: cctki_use_n_tmp1_cgfn = kind(n_tmp1_cgfn)
  COMPLEX*16 n_tmp1_cgfs (X0CmplxGA,X1CmplxGA)
  integer, parameter :: cctki_use_n_tmp1_cgfs = kind(n_tmp1_cgfs)
  REAL*8 n_tmp1_rgfn (X0ReGA,X1ReGA)
  integer, parameter :: cctki_use_n_tmp1_rgfn = kind(n_tmp1_rgfn)
  REAL*8 n_tmp1_rgfs (X0ReGA,X1ReGA)
  integer, parameter :: cctki_use_n_tmp1_rgfs = kind(n_tmp1_rgfs)
  COMPLEX*16 n_tmp2_cgfn (X0CmplxGA,X1CmplxGA)
  integer, parameter :: cctki_use_n_tmp2_cgfn = kind(n_tmp2_cgfn)
  COMPLEX*16 n_tmp2_cgfs (X0CmplxGA,X1CmplxGA)
  integer, parameter :: cctki_use_n_tmp2_cgfs = kind(n_tmp2_cgfs)
  REAL*8 n_tmp2_rgfn (X0ReGA,X1ReGA)
  integer, parameter :: cctki_use_n_tmp2_rgfn = kind(n_tmp2_rgfn)
  REAL*8 n_tmp2_rgfs (X0ReGA,X1ReGA)
  integer, parameter :: cctki_use_n_tmp2_rgfs = kind(n_tmp2_rgfs)
  COMPLEX*16 n_tmp3_cgfn (X0CmplxGA,X1CmplxGA)
  integer, parameter :: cctki_use_n_tmp3_cgfn = kind(n_tmp3_cgfn)
  COMPLEX*16 n_tmp3_cgfs (X0CmplxGA,X1CmplxGA)
  integer, parameter :: cctki_use_n_tmp3_cgfs = kind(n_tmp3_cgfs)
  COMPLEX*16 nzeta (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_nzeta = kind(nzeta)
  COMPLEX*16 nzetabar (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_nzetabar = kind(nzetabar)
  INTEGER*4 patch_index (X0patch_index,X1patch_index,patch_index_length)
  integer, parameter :: cctki_use_patch_index = kind(patch_index)
  REAL*8 redshiftB (X0RNewsArrs,X1RNewsArrs,RNewsArrs_length)
  integer, parameter :: cctki_use_redshiftB = kind(redshiftB)
  COMPLEX*16 sigmaJn (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_sigmaJn = kind(sigmaJn)
  COMPLEX*16 sigmaJo (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_sigmaJo = kind(sigmaJo)
  COMPLEX*16 sigmaKn (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_sigmaKn = kind(sigmaKn)
  COMPLEX*16 sigmaKo (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_sigmaKo = kind(sigmaKo)
  COMPLEX*16 sigmarn (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_sigmarn = kind(sigmarn)
  COMPLEX*16 sigmaro (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_sigmaro = kind(sigmaro)
  COMPLEX*16 sigmarun (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_sigmarun = kind(sigmarun)
  COMPLEX*16 sigmaruo (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_sigmaruo = kind(sigmaruo)
  COMPLEX*16 sigmaun (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_sigmaun = kind(sigmaun)
  COMPLEX*16 sigmauo (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_sigmauo = kind(sigmauo)
  COMPLEX*16 sigmauun (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_sigmauun = kind(sigmauun)
  COMPLEX*16 sigmauuo (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_sigmauuo = kind(sigmauuo)
  INTEGER*4 starting
  integer, parameter :: cctki_use_starting = kind(starting)
  REAL*8 uBondin (X0RNewsArrs,X1RNewsArrs,RNewsArrs_length)
  integer, parameter :: cctki_use_uBondin = kind(uBondin)
  REAL*8 uBondio (X0RNewsArrs,X1RNewsArrs,RNewsArrs_length)
  integer, parameter :: cctki_use_uBondio = kind(uBondio)
  COMPLEX*16 zEvolh (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_zEvolh = kind(zEvolh)
  COMPLEX*16 zEvoln (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_zEvoln = kind(zEvoln)
  COMPLEX*16 zEvolo (X0CNewsArrs,X1CNewsArrs,CNewsArrs_length)
  integer, parameter :: cctki_use_zEvolo = kind(zEvolo)
  INTEGER JJ_l_length
  INTEGER NewsB_length
  INTEGER NewsB_past_length
  INTEGER NewsB_uBondi_length
  INTEGER News_length
  INTEGER News_past_length
  INTEGER News_uBondi_length
  INTEGER Psi4_length
  INTEGER Psi4_past_length
  INTEGER Psi4_uBondi_length
  INTEGER X0EG_mask
  INTEGER X0EQ_mask
  INTEGER X0EV_mask
  INTEGER X0JJ_l
  INTEGER X0News
  INTEGER X0NewsB
  INTEGER X0NewsB_past
  INTEGER X0NewsB_uBondi
  INTEGER X0News_past
  INTEGER X0News_uBondi
  INTEGER X0NullGrParArrI
  INTEGER X0NullGrParArrR
  INTEGER X0Psi4
  INTEGER X0Psi4_past
  INTEGER X0Psi4_uBondi
  INTEGER X0RadCrd
  INTEGER X0StCmCrd
  INTEGER X0StCrd
  INTEGER X0cmplxcharfuncs_aux
  INTEGER X0cmplxcharfuncs_basic
  INTEGER X0guard_mask
  INTEGER X0linStrain
  INTEGER X0linStrain_past
  INTEGER X0linStrain_uBondi
  INTEGER X0null_mask
  INTEGER X0omega
  INTEGER X0realcharfuncs
  INTEGER X0tmp_cgf
  INTEGER X0tmp_cgf3
  INTEGER X0tmp_rgf
  INTEGER X0uBondi
  INTEGER X0uBondi_past
  INTEGER X1EG_mask
  INTEGER X1EQ_mask
  INTEGER X1EV_mask
  INTEGER X1JJ_l
  INTEGER X1News
  INTEGER X1NewsB
  INTEGER X1NewsB_past
  INTEGER X1NewsB_uBondi
  INTEGER X1News_past
  INTEGER X1News_uBondi
  INTEGER X1Psi4
  INTEGER X1Psi4_past
  INTEGER X1Psi4_uBondi
  INTEGER X1StCmCrd
  INTEGER X1StCrd
  INTEGER X1cmplxcharfuncs_aux
  INTEGER X1cmplxcharfuncs_basic
  INTEGER X1guard_mask
  INTEGER X1linStrain
  INTEGER X1linStrain_past
  INTEGER X1linStrain_uBondi
  INTEGER X1null_mask
  INTEGER X1omega
  INTEGER X1realcharfuncs
  INTEGER X1tmp_cgf
  INTEGER X1tmp_cgf3
  INTEGER X1tmp_rgf
  INTEGER X1uBondi
  INTEGER X1uBondi_past
  INTEGER cmplxcharfuncs_aux_length
  INTEGER cmplxcharfuncs_basic_length
  INTEGER linStrain_length
  INTEGER linStrain_past_length
  INTEGER linStrain_uBondi_length
  INTEGER omega_length
  INTEGER realcharfuncs_length
  INTEGER uBondi_length
  INTEGER uBondi_past_length
  INTEGER*4 EG_mask (X0EG_mask,X1EG_mask)
  integer, parameter :: cctki_use_EG_mask = kind(EG_mask)
  INTEGER*4 EQ_mask (X0EQ_mask,X1EQ_mask)
  integer, parameter :: cctki_use_EQ_mask = kind(EQ_mask)
  INTEGER*4 EV_mask (X0EV_mask,X1EV_mask)
  integer, parameter :: cctki_use_EV_mask = kind(EV_mask)
  COMPLEX*16 Jn_l (X0JJ_l,X1JJ_l,JJ_l_length)
  integer, parameter :: cctki_use_Jn_l = kind(Jn_l)
  COMPLEX*16 Jo_l (X0JJ_l,X1JJ_l,JJ_l_length)
  integer, parameter :: cctki_use_Jo_l = kind(Jo_l)
  COMPLEX*16 News (X0News,X1News,News_length)
  integer, parameter :: cctki_use_News = kind(News)
  COMPLEX*16 NewsB (X0NewsB,X1NewsB,NewsB_length)
  integer, parameter :: cctki_use_NewsB = kind(NewsB)
  COMPLEX*16 NewsB_past (X0NewsB_past,X1NewsB_past,NewsB_past_length)
  integer, parameter :: cctki_use_NewsB_past = kind(NewsB_past)
  COMPLEX*16 NewsB_uBondi (X0NewsB_uBondi,X1NewsB_uBondi,NewsB_uBondi_length)
  integer, parameter :: cctki_use_NewsB_uBondi = kind(NewsB_uBondi)
  COMPLEX*16 News_past (X0News_past,X1News_past,News_past_length)
  integer, parameter :: cctki_use_News_past = kind(News_past)
  COMPLEX*16 News_uBondi (X0News_uBondi,X1News_uBondi,News_uBondi_length)
  integer, parameter :: cctki_use_News_uBondi = kind(News_uBondi)
  COMPLEX*16 Psi4 (X0Psi4,X1Psi4,Psi4_length)
  integer, parameter :: cctki_use_Psi4 = kind(Psi4)
  COMPLEX*16 Psi4_past (X0Psi4_past,X1Psi4_past,Psi4_past_length)
  integer, parameter :: cctki_use_Psi4_past = kind(Psi4_past)
  COMPLEX*16 Psi4_uBondi (X0Psi4_uBondi,X1Psi4_uBondi,Psi4_uBondi_length)
  integer, parameter :: cctki_use_Psi4_uBondi = kind(Psi4_uBondi)
  REAL*8 bcn (X0realcharfuncs,X1realcharfuncs,realcharfuncs_length)
  integer, parameter :: cctki_use_bcn = kind(bcn)
  REAL*8 bcn_p (X0realcharfuncs,X1realcharfuncs,realcharfuncs_length)
  integer, parameter :: cctki_use_bcn_p = kind(bcn_p)
  REAL*8 bcs (X0realcharfuncs,X1realcharfuncs,realcharfuncs_length)
  integer, parameter :: cctki_use_bcs = kind(bcs)
  REAL*8 bcs_p (X0realcharfuncs,X1realcharfuncs,realcharfuncs_length)
  integer, parameter :: cctki_use_bcs_p = kind(bcs_p)
  INTEGER*4 boundary_maskn (X0null_mask,X1null_mask)
  integer, parameter :: cctki_use_boundary_maskn = kind(boundary_maskn)
  INTEGER*4 boundary_masks (X0null_mask,X1null_mask)
  integer, parameter :: cctki_use_boundary_masks = kind(boundary_masks)
  COMPLEX*16 cbcn (X0cmplxcharfuncs_aux,X1cmplxcharfuncs_aux,cmplxcharfuncs_aux_length)
  integer, parameter :: cctki_use_cbcn = kind(cbcn)
  COMPLEX*16 cbcn_p (X0cmplxcharfuncs_aux,X1cmplxcharfuncs_aux,cmplxcharfuncs_aux_length)
  integer, parameter :: cctki_use_cbcn_p = kind(cbcn_p)
  COMPLEX*16 cbcs (X0cmplxcharfuncs_aux,X1cmplxcharfuncs_aux,cmplxcharfuncs_aux_length)
  integer, parameter :: cctki_use_cbcs = kind(cbcs)
  COMPLEX*16 cbcs_p (X0cmplxcharfuncs_aux,X1cmplxcharfuncs_aux,cmplxcharfuncs_aux_length)
  integer, parameter :: cctki_use_cbcs_p = kind(cbcs_p)
  COMPLEX*16 ckcn (X0cmplxcharfuncs_aux,X1cmplxcharfuncs_aux,cmplxcharfuncs_aux_length)
  integer, parameter :: cctki_use_ckcn = kind(ckcn)
  COMPLEX*16 ckcn_p (X0cmplxcharfuncs_aux,X1cmplxcharfuncs_aux,cmplxcharfuncs_aux_length)
  integer, parameter :: cctki_use_ckcn_p = kind(ckcn_p)
  COMPLEX*16 ckcs (X0cmplxcharfuncs_aux,X1cmplxcharfuncs_aux,cmplxcharfuncs_aux_length)
  integer, parameter :: cctki_use_ckcs = kind(ckcs)
  COMPLEX*16 ckcs_p (X0cmplxcharfuncs_aux,X1cmplxcharfuncs_aux,cmplxcharfuncs_aux_length)
  integer, parameter :: cctki_use_ckcs_p = kind(ckcs_p)
  REAL*8 constant_uBondi
  integer, parameter :: cctki_use_constant_uBondi = kind(constant_uBondi)
  COMPLEX*16 dxjcn (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_dxjcn = kind(dxjcn)
  COMPLEX*16 dxjcn_p (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_dxjcn_p = kind(dxjcn_p)
  COMPLEX*16 dxjcs (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_dxjcs = kind(dxjcs)
  COMPLEX*16 dxjcs_p (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_dxjcs_p = kind(dxjcs_p)
  COMPLEX*16 eth2jcn (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_eth2jcn = kind(eth2jcn)
  COMPLEX*16 eth2jcn_p (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_eth2jcn_p = kind(eth2jcn_p)
  COMPLEX*16 eth2jcs (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_eth2jcs = kind(eth2jcs)
  COMPLEX*16 eth2jcs_p (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_eth2jcs_p = kind(eth2jcs_p)
  INTEGER*4 evolution_maskn (X0null_mask,X1null_mask)
  integer, parameter :: cctki_use_evolution_maskn = kind(evolution_maskn)
  INTEGER*4 evolution_masks (X0null_mask,X1null_mask)
  integer, parameter :: cctki_use_evolution_masks = kind(evolution_masks)
  REAL*8 evolution_radius
  integer, parameter :: cctki_use_evolution_radius = kind(evolution_radius)
  INTEGER*4 guard_mask (X0guard_mask,X1guard_mask)
  integer, parameter :: cctki_use_guard_mask = kind(guard_mask)
  COMPLEX*16 jcn (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_jcn = kind(jcn)
  COMPLEX*16 jcn_p (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_jcn_p = kind(jcn_p)
  COMPLEX*16 jcs (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_jcs = kind(jcs)
  COMPLEX*16 jcs_p (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_jcs_p = kind(jcs_p)
  COMPLEX*16 linStrain (X0linStrain,X1linStrain,linStrain_length)
  integer, parameter :: cctki_use_linStrain = kind(linStrain)
  COMPLEX*16 linStrain_past (X0linStrain_past,X1linStrain_past,linStrain_past_length)
  integer, parameter :: cctki_use_linStrain_past = kind(linStrain_past)
  COMPLEX*16 linStrain_uBondi (X0linStrain_uBondi,X1linStrain_uBondi,linStrain_uBondi_length)
  integer, parameter :: cctki_use_linStrain_uBondi = kind(linStrain_uBondi)
  COMPLEX*16 nucn (X0cmplxcharfuncs_aux,X1cmplxcharfuncs_aux,cmplxcharfuncs_aux_length)
  integer, parameter :: cctki_use_nucn = kind(nucn)
  COMPLEX*16 nucn_p (X0cmplxcharfuncs_aux,X1cmplxcharfuncs_aux,cmplxcharfuncs_aux_length)
  integer, parameter :: cctki_use_nucn_p = kind(nucn_p)
  COMPLEX*16 nucs (X0cmplxcharfuncs_aux,X1cmplxcharfuncs_aux,cmplxcharfuncs_aux_length)
  integer, parameter :: cctki_use_nucs = kind(nucs)
  COMPLEX*16 nucs_p (X0cmplxcharfuncs_aux,X1cmplxcharfuncs_aux,cmplxcharfuncs_aux_length)
  integer, parameter :: cctki_use_nucs_p = kind(nucs_p)
  REAL*8 null_delta (X0NullGrParArrR)
  integer, parameter :: cctki_use_null_delta = kind(null_delta)
  REAL*8 null_dx
  integer, parameter :: cctki_use_null_dx = kind(null_dx)
  INTEGER*4 null_gsh (X0NullGrParArrI)
  integer, parameter :: cctki_use_null_gsh = kind(null_gsh)
  INTEGER*4 null_lbnd (X0NullGrParArrI)
  integer, parameter :: cctki_use_null_lbnd = kind(null_lbnd)
  INTEGER*4 null_lsh (X0NullGrParArrI)
  integer, parameter :: cctki_use_null_lsh = kind(null_lsh)
  REAL*8 null_rb (X0RadCrd)
  integer, parameter :: cctki_use_null_rb = kind(null_rb)
  REAL*8 null_rbh (X0RadCrd)
  integer, parameter :: cctki_use_null_rbh = kind(null_rbh)
  INTEGER*4 null_ubnd (X0NullGrParArrI)
  integer, parameter :: cctki_use_null_ubnd = kind(null_ubnd)
  REAL*8 null_xb (X0RadCrd)
  integer, parameter :: cctki_use_null_xb = kind(null_xb)
  REAL*8 null_xbh (X0RadCrd)
  integer, parameter :: cctki_use_null_xbh = kind(null_xbh)
  REAL*8 omegan (X0omega,X1omega,omega_length)
  integer, parameter :: cctki_use_omegan = kind(omegan)
  REAL*8 omegao (X0omega,X1omega,omega_length)
  integer, parameter :: cctki_use_omegao = kind(omegao)
  COMPLEX*16 qcn (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_qcn = kind(qcn)
  COMPLEX*16 qcn_p (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_qcn_p = kind(qcn_p)
  COMPLEX*16 qcs (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_qcs = kind(qcs)
  COMPLEX*16 qcs_p (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_qcs_p = kind(qcs_p)
  REAL*8 qsize
  integer, parameter :: cctki_use_qsize = kind(qsize)
  REAL*8 stereo_p (X0StCrd,X1StCrd)
  integer, parameter :: cctki_use_stereo_p = kind(stereo_p)
  REAL*8 stereo_pp (X0StCrd,X1StCrd)
  integer, parameter :: cctki_use_stereo_pp = kind(stereo_pp)
  REAL*8 stereo_q (X0StCrd,X1StCrd)
  integer, parameter :: cctki_use_stereo_q = kind(stereo_q)
  REAL*8 time_of_news
  integer, parameter :: cctki_use_time_of_news = kind(time_of_news)
  COMPLEX*16 tmp_cgfn (X0tmp_cgf,X1tmp_cgf)
  integer, parameter :: cctki_use_tmp_cgfn = kind(tmp_cgfn)
  COMPLEX*16 tmp_cgfn1 (X0tmp_cgf3,X1tmp_cgf3)
  integer, parameter :: cctki_use_tmp_cgfn1 = kind(tmp_cgfn1)
  COMPLEX*16 tmp_cgfn2 (X0tmp_cgf3,X1tmp_cgf3)
  integer, parameter :: cctki_use_tmp_cgfn2 = kind(tmp_cgfn2)
  COMPLEX*16 tmp_cgfn3 (X0tmp_cgf3,X1tmp_cgf3)
  integer, parameter :: cctki_use_tmp_cgfn3 = kind(tmp_cgfn3)
  COMPLEX*16 tmp_cgfs (X0tmp_cgf,X1tmp_cgf)
  integer, parameter :: cctki_use_tmp_cgfs = kind(tmp_cgfs)
  COMPLEX*16 tmp_cgfs1 (X0tmp_cgf3,X1tmp_cgf3)
  integer, parameter :: cctki_use_tmp_cgfs1 = kind(tmp_cgfs1)
  COMPLEX*16 tmp_cgfs2 (X0tmp_cgf3,X1tmp_cgf3)
  integer, parameter :: cctki_use_tmp_cgfs2 = kind(tmp_cgfs2)
  COMPLEX*16 tmp_cgfs3 (X0tmp_cgf3,X1tmp_cgf3)
  integer, parameter :: cctki_use_tmp_cgfs3 = kind(tmp_cgfs3)
  REAL*8 tmp_rgfn (X0tmp_rgf,X1tmp_rgf)
  integer, parameter :: cctki_use_tmp_rgfn = kind(tmp_rgfn)
  REAL*8 tmp_rgfs (X0tmp_rgf,X1tmp_rgf)
  integer, parameter :: cctki_use_tmp_rgfs = kind(tmp_rgfs)
  REAL*8 uBondi (X0uBondi,X1uBondi,uBondi_length)
  integer, parameter :: cctki_use_uBondi = kind(uBondi)
  REAL*8 uBondi_past (X0uBondi_past,X1uBondi_past,uBondi_past_length)
  integer, parameter :: cctki_use_uBondi_past = kind(uBondi_past)
  COMPLEX*16 ucn (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_ucn = kind(ucn)
  COMPLEX*16 ucn_p (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_ucn_p = kind(ucn_p)
  COMPLEX*16 ucs (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_ucs = kind(ucs)
  COMPLEX*16 ucs_p (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_ucs_p = kind(ucs_p)
  REAL*8 wcn (X0realcharfuncs,X1realcharfuncs,realcharfuncs_length)
  integer, parameter :: cctki_use_wcn = kind(wcn)
  REAL*8 wcn_p (X0realcharfuncs,X1realcharfuncs,realcharfuncs_length)
  integer, parameter :: cctki_use_wcn_p = kind(wcn_p)
  REAL*8 wcs (X0realcharfuncs,X1realcharfuncs,realcharfuncs_length)
  integer, parameter :: cctki_use_wcs = kind(wcs)
  REAL*8 wcs_p (X0realcharfuncs,X1realcharfuncs,realcharfuncs_length)
  integer, parameter :: cctki_use_wcs_p = kind(wcs_p)
  COMPLEX*16 zeta (X0StCmCrd,X1StCmCrd)
  integer, parameter :: cctki_use_zeta = kind(zeta)
  INTEGER*4 linearized_news
  integer, parameter :: cctki_use_linearized_news = kind(linearized_news)
  COMMON /NullNewsrest/linearized_news
  REAL*8 eps_omega
  integer, parameter :: cctki_use_eps_omega = kind(eps_omega)
  INTEGER*4 DEBUG_skip_BondiNews
  integer, parameter :: cctki_use_DEBUG_skip_BondiNews = kind(DEBUG_skip_BondiNews)
  INTEGER*4 Jl_deriv_order
  integer, parameter :: cctki_use_Jl_deriv_order = kind(Jl_deriv_order)
  INTEGER*4 NewsSpinWeight
  integer, parameter :: cctki_use_NewsSpinWeight = kind(NewsSpinWeight)
  INTEGER*4 Ylm_at_Scri
  integer, parameter :: cctki_use_Ylm_at_Scri = kind(Ylm_at_Scri)
  INTEGER*4 compute_lin_strain
  integer, parameter :: cctki_use_compute_lin_strain = kind(compute_lin_strain)
  INTEGER*4 debug_output
  integer, parameter :: cctki_use_debug_output = kind(debug_output)
  INTEGER*4 filter_news
  integer, parameter :: cctki_use_filter_news = kind(filter_news)
  INTEGER*4 filter_omega
  integer, parameter :: cctki_use_filter_omega = kind(filter_omega)
  INTEGER*4 filter_scri_fields
  integer, parameter :: cctki_use_filter_scri_fields = kind(filter_scri_fields)
  INTEGER*4 first_order_scheme
  integer, parameter :: cctki_use_first_order_scheme = kind(first_order_scheme)
  INTEGER*4 interp_to_constant_uBondi
  integer, parameter :: cctki_use_interp_to_constant_uBondi = kind(interp_to_constant_uBondi)
  INTEGER*4 l_YlmScri
  integer, parameter :: cctki_use_l_YlmScri = kind(l_YlmScri)
  INTEGER*4 linearized_inertial_frame
  integer, parameter :: cctki_use_linearized_inertial_frame = kind(linearized_inertial_frame)
  INTEGER*4 m_YlmScri
  integer, parameter :: cctki_use_m_YlmScri = kind(m_YlmScri)
  INTEGER*4 mask_NewsB
  integer, parameter :: cctki_use_mask_NewsB = kind(mask_NewsB)
  INTEGER*4 mask_Psi4
  integer, parameter :: cctki_use_mask_Psi4 = kind(mask_Psi4)
  INTEGER*4 max_timelevels
  integer, parameter :: cctki_use_max_timelevels = kind(max_timelevels)
  INTEGER*4 news_interp_order
  integer, parameter :: cctki_use_news_interp_order = kind(news_interp_order)
  INTEGER*4 use_linearized_omega
  integer, parameter :: cctki_use_use_linearized_omega = kind(use_linearized_omega)
  INTEGER*4 write_spherical_harmonics
  integer, parameter :: cctki_use_write_spherical_harmonics = kind(write_spherical_harmonics)
  COMMON /NullNewspriv/eps_omega, DEBUG_skip_BondiNews, Jl_deriv_order, NewsSpinWeight, Ylm_at_Scri, compute_lin_strain, debug_outp&
  &ut, filter_news, filter_omega, filter_scri_fields, first_order_scheme, interp_to_constant_uBondi, l_YlmScri, linearized_inertial&
  &_frame, m_YlmScri, mask_NewsB, mask_Psi4, max_timelevels, news_interp_order, use_linearized_omega, write_spherical_harmonics
  REAL*8 CCTKH0
  integer, parameter :: cctki_use_CCTKH0 = kind(CCTKH0)
  REAL*8 CCTKH1
  integer, parameter :: cctki_use_CCTKH1 = kind(CCTKH1)
  REAL*8 CCTKH2
  integer, parameter :: cctki_use_CCTKH2 = kind(CCTKH2)
  integer*8 CCTKH3
  integer, parameter :: cctki_use_CCTKH3 = kind(CCTKH3)
  integer*8 CCTKH4
  integer, parameter :: cctki_use_CCTKH4 = kind(CCTKH4)
  INTEGER*4 cctk_itlast
  integer, parameter :: cctki_use_cctk_itlast = kind(cctk_itlast)
  INTEGER*4 CCTKH5
  integer, parameter :: cctki_use_CCTKH5 = kind(CCTKH5)
  COMMON /CACTUSrest/CCTKH0, CCTKH1, CCTKH2, CCTKH3, CCTKH4, cctk_itlast, CCTKH5
  REAL*8 null_rwt
  integer, parameter :: cctki_use_null_rwt = kind(null_rwt)
  REAL*8 CCTKH6
  integer, parameter :: cctki_use_CCTKH6 = kind(CCTKH6)
  INTEGER*4 N_ang_ev_outside_eq
  integer, parameter :: cctki_use_N_ang_ev_outside_eq = kind(N_ang_ev_outside_eq)
  INTEGER*4 N_ang_ghost_pts
  integer, parameter :: cctki_use_N_ang_ghost_pts = kind(N_ang_ghost_pts)
  INTEGER*4 N_ang_pts_inside_eq
  integer, parameter :: cctki_use_N_ang_pts_inside_eq = kind(N_ang_pts_inside_eq)
  INTEGER*4 N_ang_stencil_size
  integer, parameter :: cctki_use_N_ang_stencil_size = kind(N_ang_stencil_size)
  INTEGER*4 N_radial_pts
  integer, parameter :: cctki_use_N_radial_pts = kind(N_radial_pts)
  INTEGER*4 CCTKH7
  integer, parameter :: cctki_use_CCTKH7 = kind(CCTKH7)
  COMMON /NULLGRIDrest/null_rwt, CCTKH6, N_ang_ev_outside_eq, N_ang_ghost_pts, N_ang_pts_inside_eq, N_ang_stencil_size, N_radial_pt&
  &s, CCTKH7

  INTEGER*4, parameter :: izero = 0
  integer, parameter :: ik = kind(izero)

  

  if (filter_scri_fields.ne.0) then
     if (FirstTime) then
        FirstTime = .false.
        allocate(temp(null_lsh(1), null_lsh(2), 2))
     endif
  endif

  

  call NullNews_cscrival (null_lsh, N_radial_pts, jcn_p, jcs_p, Jo)
  call NullNews_cscrival (null_lsh, N_radial_pts, jcn, jcs, Jn)

  call NullNews_cscridbydl (Jl_deriv_order, null_lsh, N_radial_pts, null_dx, null_rwt, jcn_p, jcs_p, Jo_l)
  call NullNews_cscridbydl (Jl_deriv_order, null_lsh, N_radial_pts, null_dx, null_rwt, jcn, jcs, Jn_l)

  call NullNews_rscrival (null_lsh, N_radial_pts, bcn_p, bcs_p, betao)
  call NullNews_rscrival (null_lsh, N_radial_pts, bcn, bcs, betan)

  call NullNews_rscrival (null_lsh, N_radial_pts, wcn, wcs, Wn)

  if (first_order_scheme.ne.0) then
    call NullNews_cscrival (null_lsh, N_radial_pts, cbcn_p, cbcs_p, cBo)
    call NullNews_cscrival (null_lsh, N_radial_pts, cbcn, cbcs, cBn)
  end if

  call NullNews_cscrival (null_lsh, N_radial_pts, qcn_p, qcs_p, Qo)
  call NullNews_cscrival (null_lsh, N_radial_pts, qcn, qcs, Qn)

  call NullNews_cscridbydl (Jl_deriv_order, null_lsh, N_radial_pts, null_dx, null_rwt, qcn_p, qcs_p, Qo_l)
  call NullNews_cscridbydl (Jl_deriv_order, null_lsh, N_radial_pts, null_dx, null_rwt, qcn, qcs, Qn_l)

  call NullNews_cscrivalh (null_lsh, N_radial_pts, ucn_p, ucs_p, Uo)
  call NullNews_cscrivalh (null_lsh, N_radial_pts, ucn, ucs, Un)

  
  call NullNews_cscridbydlh (null_lsh, N_radial_pts, null_dx, null_rwt, ucn_p, ucs_p, Uo_l)
  call NullNews_cscridbydlh (null_lsh, N_radial_pts, null_dx, null_rwt, ucn, ucs, Un_l)

  call NullNews_cscridbydl2h (null_lsh, N_radial_pts, null_dx, null_rwt, ucn_p, ucs_p, Uo_l_l)
  call NullNews_cscridbydl2h (null_lsh, N_radial_pts, null_dx, null_rwt, ucn, ucs, Un_l_l)

  if (filter_scri_fields .ne. 0) then
     call SpinDecompFilter(cctkGH, null_lsh(1), null_lsh(2), 2_ik, zeta, Jo)
     call SpinDecompFilter(cctkGH, null_lsh(1), null_lsh(2), 2_ik, zeta, Jn)

     call SpinDecompFilter(cctkGH, null_lsh(1), null_lsh(2), 2_ik, zeta, Jo_l)
     call SpinDecompFilter(cctkGH, null_lsh(1), null_lsh(2), 2_ik, zeta, Jn_l)

     temp = betao
     call SpinDecompFilter(cctkGH, null_lsh(1), null_lsh(2), 0_ik, zeta, temp)
     betao = dble(temp)

     temp = betan
     call SpinDecompFilter(cctkGH, null_lsh(1), null_lsh(2), 0_ik, zeta, temp)
     betan = dble(temp)

     if (first_order_scheme.ne.0) then
       call SpinDecompFilter(cctkGH, null_lsh(1), null_lsh(2), 1_ik, zeta, cBo)
       call SpinDecompFilter(cctkGH, null_lsh(1), null_lsh(2), 1_ik, zeta, cBn)
     end if

     call SpinDecompFilter(cctkGH, null_lsh(1), null_lsh(2), 1_ik, zeta, Qo)
     call SpinDecompFilter(cctkGH, null_lsh(1), null_lsh(2), 1_ik, zeta, Qn)
     call SpinDecompFilter(cctkGH, null_lsh(1), null_lsh(2), 2_ik, zeta, Qo_l)
     call SpinDecompFilter(cctkGH, null_lsh(1), null_lsh(2), 2_ik, zeta, Qn_l)

     call SpinDecompFilter(cctkGH, null_lsh(1), null_lsh(2), 1_ik, zeta, Uo)
     call SpinDecompFilter(cctkGH, null_lsh(1), null_lsh(2), 1_ik, zeta, Un)

     
     call SpinDecompFilter(cctkGH, null_lsh(1), null_lsh(2), 2_ik, zeta, Uo_l)
     call SpinDecompFilter(cctkGH, null_lsh(1), null_lsh(2), 2_ik, zeta, Un_l)

     call SpinDecompFilter(cctkGH, null_lsh(1), null_lsh(2), 2_ik, zeta, Uo_l_l)
     call SpinDecompFilter(cctkGH, null_lsh(1), null_lsh(2), 2_ik, zeta, Un_l_l)


  endif

end subroutine NullNews_ScriVals

